<?php

// has user hopped to a category?
if (substr($forumid,0,3)=="cat") {
  $categoryid=substr($forumid,3);
  header("Location: index.php?categoryid=$categoryid");
  exit;
}

require("global.php");

// set defaults
if (isset($perpage)==0 or $perpage==0) {
  $perpage=$maxthreads;
}
if (isset($pagenumber)==0 or $pagenumber==0) {
  $pagenumber=1;
}

$forumid = verifyid("forum",$forumid);

$getperms=getpermissions($bbuserid,$bbusergroupid,$forumid);
if ($getperms[canview]==0) {
  eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
  exit;
}

makeforumjump();

$foruminfo=$DB_site->query_first("SELECT title,description,categoryid,active,daysprune,titleimage,forumtemplate,forumbittemplate,newthreadimage,headertemplate,useadvheader,footertemplate,useadvfooter,rulestemplate,allowbbcode,allowimages,allowhtml,allowsmilies FROM forum WHERE forumid=$forumid");
$forumtitle=htmlspecialchars($foruminfo[title]);
if ($foruminfo[active]==0) {
  echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
  exit;
}
if ($foruminfo[titleimage]!="") {
  $titleimage=$foruminfo[titleimage];
}
if ($foruminfo[forumtemplate]!="") {
  $usetemplate=$foruminfo[forumtemplate];
} else {
  $usetemplate="forumdisplay";
}
if ($foruminfo[forumbittemplate]!="") {
  $usetemplatebit=$foruminfo[forumbittemplate];
} else {
  $usetemplatebit="forumdisplaybit";
}
if ($foruminfo[newthreadimage]!="") {
  $newthreadimage=$foruminfo[newthreadimage];
}

$bbcodeon=iif($foruminfo[allowbbcode]==1,$ontext,$offtext);
$imgcodeon=iif($foruminfo[allowimages]==1,$ontext,$offtext);
$htmlcodeon=iif($foruminfo[allowhtml]==1,$ontext,$offtext);
$smilieson=iif($foruminfo[allowsmilies]==1,$ontext,$offtext);
if ($foruminfo[rulestemplate]!="") {
  eval("\$forumrules = \"".gettemplate("$foruminfo[rulestemplate]")."\";");
} else {
  eval("\$forumrules = \"".gettemplate("forumrules")."\";");
}

if (isset($daysprune)==0 or $daysprune==0 or $daysprune==-1) {
  $daysprune=$foruminfo[daysprune];
}

$getcategory=$DB_site->query_first("SELECT title,categoryid FROM category WHERE category.categoryid=$foruminfo[categoryid]");
$categorytitle=$getcategory[title];
$categoryid=$getcategory[categoryid];

// get announcements
$datenow=time();
if ($announcement=$DB_site->query_first("SELECT announcementid,userid,startdate,title FROM announcement WHERE startdate<=$datenow AND enddate>=$datenow AND (forumid=$forumid OR forumid=-1) ORDER BY startdate DESC LIMIT 1")) {
  $announceuser=$DB_site->query_first("SELECT username,usertitle FROM user WHERE userid=$announcement[userid]");
  $announceusertitle=$announceuser[usertitle];
  $announceposter=$announceuser[username];

  $postdate=date($dateformat,$announcement[startdate]);

  $announcementtitle=$announcement[title];

  if ($announcement[startdate]>$bblastvisit) {
    $newannounceimage="newannounce.gif";
  } else {
    $newannounceimage="announce.gif";
  }

  eval("\$announcement = \"".gettemplate("forumdisplay_announcement")."\";");
}

// get moderators
$forummoderators=$DB_site->query("SELECT user.username,user.userid,user.usergroupid FROM forumpermission,user WHERE user.usergroupid=forumpermission.usergroupid AND canadminedit=1 AND forumid=$forumid");
if ($moderator=$DB_site->fetch_array($forummoderators)) {
  $moderatedby="(Moderated by: <a href=\"member.php?action=getinfo&userid=$moderator[userid]\">".htmlspecialchars($moderator[username])."</a>";

  while ($moderator=$DB_site->fetch_array($forummoderators)) {
    $moderatedby.=", <a href=\"member.php?action=getinfo&userid=$moderator[userid]\">".htmlspecialchars($moderator[username])."</a>";
  }
  $moderatedby.=")";

} else {
  $moderatedby="";
}

$description=htmlspecialchars($foruminfo[description]);
$forumtitle=htmlspecialchars($foruminfo[title]);

$varname="daysprune$daysprune"."selected";
$$varname="selected";

$limitlower=($pagenumber-1)*$perpage;

if ($daysprune!=1000) {
  $datecut="AND lastpost >= ".(time() - ($daysprune*86400));
}

$threads=$DB_site->query("SELECT threadid,title,open,lastpost,replycount,postusername,lastposter,notes,iconid,views FROM thread WHERE forumid=$forumid AND visible=1 $datecut ORDER BY lastpost DESC LIMIT $limitlower,$perpage");
while ($thread=$DB_site->fetch_array($threads)) {

  if (($thread[replycount]+1)>$maxposts and $linktopages==1) {

    $totalpages=($thread[replycount]+1)/$maxposts;
    if ($totalpages!=intval($totalpages)) {
      $totalpages=intval($totalpages)+1;
    }

    $acurpage=0;
    $pagenumbers="";
    while ($acurpage++<$totalpages) {
      if ($acurpage==$maxmultipage) {
        $pagenumbers.=" ... <a href=\"showthread.php?threadid=$thread[threadid]&pagenumber=lastpage\">Last page</a>";
        break;
      } else {
        $pagenumbers.=" <a href=\"showthread.php?threadid=$thread[threadid]&pagenumber=$acurpage\">$acurpage</a> ";
      }
    }
    eval("\$pagenav = \"".gettemplate("multipagenav")."\";");
  } else {
    $pagenav="";
  }

  if ($showicons==1 and $thread[iconid]!=0) {
    if ($icon=$DB_site->query_first("SELECT title,iconpath FROM icon WHERE iconid=$thread[iconid]")) {
      $threadicon="<img src=\"$icon[iconpath]\" alt=\"$icon[title]\" border=0>";
    } else {
      $threadicon="&nbsp;";
    }
  } else {
    $threadicon="&nbsp;";
  }

  if ($wordwrap!=0) {
    $thread[title]=dowordwrap($thread[title]);
  }
  $threadtitle=htmlspecialchars($thread[title]);
  $threadid=$thread[threadid];

  $notes=htmlspecialchars($thread[notes]);
  $replies=$thread[replycount];
  $views=$thread[views];
  $firstposter=htmlspecialchars($thread[postusername]);
  $lastposter=htmlspecialchars($thread[lastposter]);
  $lastreplydate=date($dateformat,$thread[lastpost]+(($timeoffset+$bbtimezoneoffset)*3600));
  $lastreplytime=date($timeformat,$thread[lastpost]+(($timeoffset+$bbtimezoneoffset)*3600));

  $gotonew="";

  $newoldhot="folder";
  if ($thread[open]==0) {
    $newoldhot="lock".$newoldhot;
  }
  if ($thread[replycount]>=$hotnumber and $usehotthreads==1) {
    $newoldhot="hot".$newoldhot;
  }
  if ($lastvisitdate=="Never") {
    $newoldhot="new".$newoldhot;
  } elseif ($thread[lastpost]>$bblastvisit) {
      $newoldhot="new".$newoldhot;
      eval("\$gotonew = \"".gettemplate("forumdisplay_gotonew")."\";");
  }

  eval("\$forumdisplaybits .= \"".gettemplate("$usetemplatebit")."\";");

}

$countposts=$DB_site->query_first("SELECT COUNT(thread.threadid) AS threads FROM thread WHERE thread.visible=1 AND thread.forumid=$forumid $datecut");
if ($countposts[threads]>$perpage) {

  $pagenav="Page: ";

  $totalpages=$countposts[threads]/$perpage;
  if ($totalpages!=intval($totalpages)) {
    $totalpages=intval($totalpages)+1;
  }

  $curpage=0;
  while ($curpage++<$totalpages) {

    if (($curpage<$pagenumber-$pagenavpages or $curpage>$pagenumber+$pagenavpages) and $pagenavpages!=0) {
      if ($curpage==1) {
        $pagenav.=" <a href=\"forumdisplay.php?forumid=$forumid&daysprune=$daysprune&pagenumber=$curpage".iif($perpage==$maxposts,"","&perpage=$perpage")."\">&lt;&lt; First Page</a> ... ";
      }
      if ($curpage==$totalpages) {
        $pagenav.=" ... <a href=\"forumdisplay.php?forumid=$forumid&daysprune=$daysprune&pagenumber=$curpage".iif($perpage==$maxposts,"","&perpage=$perpage")."\">Last Page &gt;&gt;</a>";
      }
    } else {
      if ($curpage==$pagenumber) {
        $pagenav.=" $curpage";
      } else {
        $pagenav.=" <a href=\"forumdisplay.php?forumid=$forumid&daysprune=$daysprune&pagenumber=$curpage".iif($perpage==$maxposts,"","&perpage=$perpage")."\">$curpage</a>";
      }
    }
  }
} else {
  $pagenav="";
}

// parse header ##################
if ($foruminfo[headertemplate]!="") {
  if ($foruminfo[useadvheader]==1) {
    eval(gettemplate("$foruminfo[headertemplate]").";");
  } else {
    eval("\$header = \"".gettemplate("$foruminfo[headertemplate]")."\";");
  }
}
if ($foruminfo[footertemplate]!="") {
  if ($foruminfo[useadvfooter]==1) {
    eval(gettemplate("$foruminfo[footertemplate]").";");
  } else {
    eval("\$footer = \"".gettemplate("$foruminfo[footertemplate]")."\";");
  }
}

eval("echo dovars(\"".gettemplate("$usetemplate")."\");");

?>