<html>
<!--
<?php

// determine if php is running
if (1==0) {
  echo "-->You are not running PHP - Please contact your system administrator.<!--";
} else {
  echo "--".">";
}

$version="1.1.3";

if ($step=="") {

?><head><title>vBulletin Install Wizard <?php echo $version; ?></title></head>
<body>

<p>Welcome to vBulletin version <?php echo $version; ?>. Running this script will do a clean install of vBulletin onto your server.</p>
<p><a href="install.php?step=2">Click here to continue -></a></p>
<?php

}

if ($step==2) {

?><head><title>vBulletin Install Wizard <?php echo $version; ?> - Check configuration of database</title></head>
<body><?php

  if (file_exists("config.php")==0) {
    ?>
<p>Cannot find config.php file.</p>

<p>Make sure that you have uploaded it and that it is in the admin directory. It should look something like this:</p>

<pre>
&lt;?
// only mysql is supported at the moment
$dbservertype="mysql";
// hostname or ip of server
$servername="localhost";
// username and password to log onto db server
$dbusername="root";
$dbpassword="";
// name of database
$dbname="forum";
?&gt;
</pre>
<?php

  } else {
    include("config.php");

    if ($dbservertype=="") {

      ?>
<p>Make sure that you have filled in all the details in the config.php file. It should look something like this:

<pre>
&lt;?
// only mysql is supported at the moment
$dbservertype="mysql";
// hostname or ip of server
$servername="localhost";
// username and password to log onto db server
$dbusername="root";
$dbpassword="";
// name of database
$dbname="forum";
?&gt;
</pre>
    <?php
    } else {

      echo "<p>Please confirm the details below:</p>\n";
      echo "<p><b>Database server type:</b> $dbservertype</p>\n";
      echo "<p><b>Database server hostname / IP address:</b> $servername</p>\n";
      echo "<p><b>Database username:</b> $dbusername</p>\n";
      echo "<p><b>Database password:</b> $dbpassword</p>\n";
      echo "<p><b>Database name:</b> $dbname</p>\n";
      echo "<p>Only continue to the next step if those details are correct. If they are not, please edit your config.php file and reupload it. The next step will test database connectivity.</p>";
      echo "<p><a href=\"install.php?step=3\">Click here to continue -></a></p>";
    }
  }
}

if ($step>=3) {
  // step 3 and after, we are ok loading this file
  include("config.php");
}

if ($step==3) {

?><head><title>vBulletin Install Wizard <?php echo $version; ?> - Check database connectivity</title></head>
<body><p>Attempting to connect...</p><?php

  // connect to db
  // load db class
  $dbclassname="db_$dbservertype.php";
  include($dbclassname);

  $DB_site=new DB_Sql_vb;

  // initialise vars
  $DB_site->appname="vBulletin Installer";
  $DB_site->appshortname="vBulletin (inst)";
  $DB_site->database=$dbname;
  $DB_site->server=$servername;
  $DB_site->user=$dbusername;
  $DB_site->password=$dbpassword;

  // allow this script to catch errors
  $DB_site->reporterror=0;

  $DB_site->connect();
  // end init db

  $errno=$DB_site->errno;

  if ($DB_site->link_id!=0) {

    if ($errno!=0) {
      if ($errno==1049) {
        echo "<p>You have specified a non existent database. Trying to create one now...</p>";
        $DB_site->query("CREATE DATABASE $dbname");
        echo "<p>Trying to connect again...</p>";
        $DB_site->select_db($dbname);

        $errno=$DB_site->geterrno();

        if ($errno==0) {
          echo "<p>Connect succeeded!</p>";
          echo "<p><a href=\"install.php?step=4\">Click here to continue -></a></p>";
        } else {
          echo "<p>Connect failed again! Please ensure that the database and server is correctly configured and try again.</p>";
          echo "<p>Click <a href=\"http://www.vbulletin.com/\"here</a> to go to the vBulletin website</p>";
        }
      } else {

        echo "<p>Connect failed: unexpected error from the database.</p>";
        echo "<p>Error number: ".$DB_site->errno."</p>";
        echo "<p>Error description: ".$DB_site->errdesc."</p>";
        echo "<p>Please ensure that the database and server is correctly configured and try again.</p>";
        echo "<p>Click <a href=\"http://www.vbulletin.com/\"here</a> to go to the vBulletin website</p>";

      }
    } else {
      // succeeded! yay!
      echo "<p>Connection succeeded! The database already exists.</p>";
      echo "<p><a href=\"install.php?step=4\">Click here to continue -></a></p>";
      echo "<p><a href=\"install.php?step=4&reset=1\">Click here to continue and reset the database to an empty one -></a></p>";

    }
  }
}

if ($step>=4) {

  // connect to db
  // load db class
  $dbclassname="db_$dbservertype.php";
  include($dbclassname);

  $DB_site=new DB_Sql_vb;

  // initialise vars
  $DB_site->appname="vBulletin Installer";
  $DB_site->appshortname="vBulletin (inst)";
  $DB_site->database=$dbname;
  $DB_site->server=$servername;
  $DB_site->user=$dbusername;
  $DB_site->password=$dbpassword;

  // allow this script to catch errors
//  $DB_site->reporterror=0;

  $DB_site->connect();
  // end init db
}

if ($step==4) {

?><head><title>vBulletin Install Wizard <?php echo $version; ?> - Set up tables</title></head>
<body><p>Setting up tables...</p><?php

  if ($reset==1) {
    echo "<p>Reseting database...";
    $DB_site->query("DROP DATABASE IF EXISTS $dbname");
    $DB_site->query("CREATE DATABASE $dbname");
    $DB_site->select_db($dbname);
    echo "succeeded</p>";
  }

  // Start generating tables and indicies
  // ###################### Start announcement #######################
  $DB_site->query("CREATE TABLE announcement (
   announcementid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   title CHAR(50) NOT NULL,
   userid SMALLINT UNSIGNED NOT NULL,
   startdate INT UNSIGNED NOT NULL,
   enddate INT UNSIGNED NOT NULL,
   pagetext MEDIUMTEXT NOT NULL,
   forumid SMALLINT NOT NULL,
   PRIMARY KEY(announcementid)
  )");

  // ###################### Start bbcode #######################
  $DB_site->query("CREATE TABLE bbcode (
   bbcodeid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   findcode TEXT NOT NULL,
   replacecode TEXT NOT NULL,
   PRIMARY KEY(bbcodeid)
  )");

  // ###################### Start category #######################
  $DB_site->query("CREATE TABLE category (
   categoryid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   title CHAR(100) NOT NULL,
   displayorder SMALLINT NOT NULL,
   PRIMARY KEY(categoryid)
  )");

  // ###################### Start forum #######################
  $DB_site->query("CREATE TABLE forum (
   forumid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   title CHAR(100) NOT NULL,
   description CHAR(250) NOT NULL,
   active SMALLINT NOT NULL,
   displayorder SMALLINT NOT NULL,
   replycount INT UNSIGNED NOT NULL,
   lastpost INT NOT NULL,
   lastposter CHAR(50) NOT NULL,
   threadcount MEDIUMINT UNSIGNED NOT NULL,
   categoryid SMALLINT UNSIGNED NOT NULL,
   allowposting SMALLINT NOT NULL,
   daysprune SMALLINT UNSIGNED NOT NULL,
   forumtemplate CHAR(100) NOT NULL,
   headertemplate CHAR(100) NOT NULL,
   useadvheader SMALLINT NOT NULL,
   footertemplate CHAR(100) NOT NULL,
   useadvfooter SMALLINT NOT NULL,
   forumbittemplate CHAR(100) NOT NULL,
   threadtemplate CHAR(100) NOT NULL,
   threadbittemplate CHAR(100) NOT NULL,
   replytemplate CHAR(100) NOT NULL,
   newthreadtemplate CHAR(100) NOT NULL,
   edittemplate CHAR(100) NOT NULL,
   rulestemplate CHAR(100) NOT NULL,
   titleimage CHAR(100) NOT NULL,
   replyimage CHAR(100) NOT NULL,
   newthreadimage CHAR(100) NOT NULL,
   closedthreadimage CHAR(100) NOT NULL,
   newpostemail CHAR(250) NOT NULL,
   newthreademail CHAR(250) NOT NULL,
   moderatenew SMALLINT NOT NULL,
   allowbbcode SMALLINT NOT NULL,
   allowimages SMALLINT NOT NULL,
   allowhtml SMALLINT NOT NULL,
   allowsmilies SMALLINT NOT NULL,
   PRIMARY KEY(forumid)
  )");

  // ###################### Start forumpermission #######################
  $DB_site->query("CREATE TABLE forumpermission (
   forumpermissionid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   forumid SMALLINT UNSIGNED NOT NULL,
   usergroupid SMALLINT UNSIGNED NOT NULL,
   canview SMALLINT NOT NULL,
   cansearch SMALLINT NOT NULL,
   canemail SMALLINT NOT NULL,
   canpostnew SMALLINT NOT NULL,
   canreply SMALLINT NOT NULL,
   canadminedit SMALLINT NOT NULL,
   canedit SMALLINT NOT NULL,
   candelete SMALLINT NOT NULL,
   canopenclose SMALLINT NOT NULL,
   canmove SMALLINT NOT NULL,
   PRIMARY KEY(forumpermissionid)
  )");

  // ###################### Start icon #######################
  $DB_site->query("CREATE TABLE icon (
   iconid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   title CHAR(100) NOT NULL,
   iconpath CHAR(100) NOT NULL,
   PRIMARY KEY(iconid)
  )");

  // ###################### Start post #######################
  $DB_site->query("CREATE TABLE post (
   postid INT UNSIGNED NOT NULL AUTO_INCREMENT,
   threadid INT UNSIGNED NOT NULL,
   username CHAR(50) NOT NULL,
   userid INT UNSIGNED NOT NULL,
   title CHAR(100) NOT NULL,
   dateline INT NOT NULL,
   pagetext MEDIUMTEXT,
   allowsmilie SMALLINT NOT NULL,
   email SMALLINT NOT NULL,
   signature SMALLINT NOT NULL,
   ipaddress CHAR(16) NOT NULL,
   iconid SMALLINT UNSIGNED NOT NULL,
   visible SMALLINT NOT NULL,
   PRIMARY KEY(postid),
   INDEX idxdisp(threadid,dateline)
  )");

  // ###################### Start replacement #######################
  $DB_site->query("CREATE TABLE replacement (
   replacementid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   findword TEXT NOT NULL,
   replaceword TEXT NOT NULL,
   PRIMARY KEY(replacementid)
  )");

  // ###################### Start session #######################
  $DB_site->query("CREATE TABLE session (
   sessionid MEDIUMINT UNSIGNED AUTO_INCREMENT NOT NULL,
   userid SMALLINT UNSIGNED NOT NULL,
   ipaddress CHAR(20) NOT NULL,
   lastactivity INT UNSIGNED NOT NULL,
   location CHAR(250) NOT NULL,
   PRIMARY KEY(sessionid)
  )");

  // ###################### Start smilie #######################
  $DB_site->query("CREATE TABLE smilie (
   smilieid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   title CHAR(100) NOT NULL,
   smilietext CHAR(10) NOT NULL,
   smiliepath CHAR(100) NOT NULL,
   PRIMARY KEY(smilieid)
  )");

  // ###################### Start template #######################
  $DB_site->query("CREATE TABLE template (
   templateid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   title CHAR(100) NOT NULL,
   template MEDIUMTEXT NOT NULL,
   PRIMARY KEY(templateid)
  )");

  // ###################### Start thread #######################
  $DB_site->query("CREATE TABLE thread (
   threadid INT UNSIGNED NOT NULL AUTO_INCREMENT,
   title CHAR(100) NOT NULL,
   lastpost INT UNSIGNED NOT NULL,
   forumid SMALLINT UNSIGNED NOT NULL,
   open SMALLINT NOT NULL,
   replycount INT UNSIGNED NOT NULL,
   postusername CHAR(50) NOT NULL,
   lastposter CHAR(50) NOT NULL,
   dateline INT UNSIGNED NOT NULL,
   views SMALLINT UNSIGNED NOT NULL,
   iconid SMALLINT UNSIGNED NOT NULL,
   notes CHAR(250) NOT NULL,
   visible SMALLINT NOT NULL,
   subjectindex CHAR(100) NOT NULL,
   threadindex MEDIUMTEXT NOT NULL,
   userindex MEDIUMTEXT NOT NULL,
   PRIMARY KEY(threadid)
  )");

  // ###################### Start user #######################
  $DB_site->query("CREATE TABLE user (
   userid INT UNSIGNED NOT NULL AUTO_INCREMENT,
   usergroupid SMALLINT UNSIGNED NOT NULL,
   username CHAR(50) NOT NULL,
   password CHAR(50) NOT NULL,
   email CHAR(50) NOT NULL,
   parentemail CHAR(50) NOT NULL,
   coppauser SMALLINT NOT NULL,
   homepage CHAR(100) NOT NULL,
   icq CHAR(20) NOT NULL,
   aim CHAR(20) NOT NULL,
   yahoo CHAR(20) NOT NULL,
   biography MEDIUMTEXT NOT NULL,
   signature MEDIUMTEXT NOT NULL,
   adminemail SMALLINT NOT NULL,
   showemail SMALLINT NOT NULL,
   invisible SMALLINT NOT NULL,
   usertitle CHAR(250) NOT NULL,
   customtitle SMALLINT NOT NULL,
   joindate INT UNSIGNED NOT NULL,
   canpost SMALLINT NOT NULL,
   cookieuser SMALLINT NOT NULL,
   daysprune SMALLINT NOT NULL,
   lastvisit INT UNSIGNED NOT NULL,
   lastactivity INT UNSIGNED NOT NULL,
   lastpost INT UNSIGNED NOT NULL,
   posts SMALLINT UNSIGNED NOT NULL,
   timezoneoffset SMALLINT NOT NULL,
   emailnotification SMALLINT NOT NULL,
   PRIMARY KEY(userid),
   INDEX idxgroups(username,usergroupid)
  )");

  // ###################### Start usergroup #######################
  $DB_site->query("CREATE TABLE usergroup (
   usergroupid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   title CHAR(100) NOT NULL,
   usertitle CHAR(100) NOT NULL,
   canview SMALLINT NOT NULL,
   cansearch SMALLINT NOT NULL,
   canemail SMALLINT NOT NULL,
   canpostnew SMALLINT NOT NULL,
   canreply SMALLINT NOT NULL,
   canadminedit SMALLINT NOT NULL,
   canedit SMALLINT NOT NULL,
   candelete SMALLINT NOT NULL,
   canopenclose SMALLINT NOT NULL,
   canmove SMALLINT NOT NULL,
   cancontrolpanel SMALLINT NOT NULL,
   PRIMARY KEY(usergroupid)
  )");

  // ###################### Start usertitle #######################
  $DB_site->query("CREATE TABLE usertitle (
   usertitleid SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
   minposts SMALLINT UNSIGNED NOT NULL,
   title CHAR(250) NOT NULL,
   PRIMARY KEY(usertitleid)
  )");

  if ($DB_site->errno!=0) {
    echo "<p>The script reported errors in the installation of the tables. Only continue if you are sure that they are not serious.</p>";
    echo "<p>The errors were:</p>";
    echo "<p>Error number: ".$DB_site->errno."</p>";
    echo "<p>Error description: ".$DB_site->errdesc."</p>";
  } else {
    echo "<p>Tables set up successfully.</p>";
  }

  echo "<p><a href=\"install.php?step=5\">Click here to continue -></a></p>";

}

if ($step==5) {
?><head><title>vBulletin Install Wizard <?php echo $version; ?> - Add default data to tables</title></head>
<body><p>Setting up tables...</p><?php

  // do bb codes
  echo "<p>Setting up bb codes...";
  $DB_site->query("INSERT INTO bbcode VALUES (NULL,'[b]','<b>')");
  $DB_site->query("INSERT INTO bbcode VALUES (NULL,'[/b]','</b>')");
  $DB_site->query("INSERT INTO bbcode VALUES (NULL,'[i]','<i>')");
  $DB_site->query("INSERT INTO bbcode VALUES (NULL,'[/i]','</i>')");
  $DB_site->query("INSERT INTO bbcode VALUES (NULL,'[u]','<u>')");
  $DB_site->query("INSERT INTO bbcode VALUES (NULL,'[/u]','</u>')");
  echo "succeeded</p>";

  echo "<p>Setting up categories...";
  $DB_site->query("INSERT INTO category (categoryid,title,displayorder) VALUES (NULL,'Main',1)");
  echo "succeeded</p>";

  echo "<p>Setting up demo forum...";
  $DB_site->query("INSERT INTO forum (forumid,title,description,active,displayorder,categoryid,allowposting,daysprune,allowbbcode,allowsmilies) VALUES (NULL,'Forum 1','Your description here',1,1,1,1,30,1,1)");
  echo "succeeded</p>";

  echo "<p>Setting up icons...";
  $DB_site->query("INSERT INTO icon VALUES (1,'Post','images/icons/icon1.gif')");
  $DB_site->query("INSERT INTO icon VALUES (2,'Arrow','images/icons/icon2.gif')");
  $DB_site->query("INSERT INTO icon VALUES (3,'Lightbulb','images/icons/icon3.gif')");
  $DB_site->query("INSERT INTO icon VALUES (4,'Exclamation','images/icons/icon4.gif')");
  $DB_site->query("INSERT INTO icon VALUES (5,'Question','images/icons/icon5.gif')");
  $DB_site->query("INSERT INTO icon VALUES (6,'Cool','images/icons/icon6.gif')");
  $DB_site->query("INSERT INTO icon VALUES (7,'Smile','images/icons/icon7.gif')");
  $DB_site->query("INSERT INTO icon VALUES (8,'Angry','images/icons/icon8.gif')");
  $DB_site->query("INSERT INTO icon VALUES (9,'Unhappy','images/icons/icon9.gif')");
  $DB_site->query("INSERT INTO icon VALUES (10,'Talking','images/icons/icon10.gif')");
  $DB_site->query("INSERT INTO icon VALUES (11,'Red face','images/icons/icon11.gif')");
  $DB_site->query("INSERT INTO icon VALUES (12,'Wink','images/icons/icon12.gif')");
  $DB_site->query("INSERT INTO icon VALUES (13,'Thumbs down','images/icons/icon13.gif')");
  $DB_site->query("INSERT INTO icon VALUES (14,'Thumbs up','images/icons/icon14.gif')");
  echo "succeeded</p>";

  echo "<p>Setting up replacements...";
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'<largefont','<b><FONT face=\"Arial, Helvetica\" color =\"#003399\" size=\"3\"')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'</largefont>','</b></font>')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'<body>','<body bgcolor=\"#ffffff\" text=\"#000000\" id=all>')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'<normalfont','<FONT SIZE=\"2\" FACE=\"arial, helvetica\"')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'</normalfont>','</font>')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'{htmldoctype}','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\" \"http://www.w3.org/TR/REC-html40/loose.dtd\">')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'<smallfont','<FONT SIZE=\"1\" FACE=\"verdana,arial,helvetica\"')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'</smallfont>','</font>')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'{firstaltcolor}','#C3C3EB')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'{secondaltcolor}','#AAAAE6')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'{tableheadtextcolor}','#FFFFFF')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'{tableheadbgcolor}','#113274')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'{timecolor}','#800080')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'{categorybackcolor}','#CFD9FF')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'{categoryfontcolor}','#000000')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'{linkcolor}','#333399')");
  $DB_site->query("INSERT INTO replacement VALUES (NULL,'{hovercolor}','#ff0000')");
  echo "succeeded</p>";

  echo "<p>Setting up smilies...";
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'smile',':)','images/smilies/smile.gif')");
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'frown',':(','images/smilies/frown.gif')");
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'embarrasment',':o','images/smilies/redface.gif')");
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'big grin',':D','images/smilies/biggrin.gif')");
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'wink',';)','images/smilies/wink.gif')");
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'stick out tongue',':p','images/smilies/tongue.gif')");
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'cool',':cool:','images/smilies/cool.gif')");
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'roll eyes (sarcastic)',':rolleyes:','images/smilies/rolleyes.gif')");
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'mad',':mad:','images/smilies/mad.gif')");
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'eek!',':eek:','images/smilies/eek.gif')");
  $DB_site->query("INSERT INTO smilie VALUES (NULL,'confused',':confused:','images/smilies/confused.gif')");
  echo "succeeded</p>";

  echo "<p>Setting up user groups...";
  $DB_site->query("INSERT INTO usergroup VALUES (1,'Unregistered / Not Logged In','Guest',1,1,1,0,0,0,0,0,0,0,0)");
  $DB_site->query("INSERT INTO usergroup VALUES (2,'Registered','',1,1,1,1,1,0,1,1,1,0,0)");
  $DB_site->query("INSERT INTO usergroup VALUES (3,'Users Awaiting Email Confirmation','',1,1,1,0,0,0,0,0,0,0,0)");
  $DB_site->query("INSERT INTO usergroup VALUES (4,'(COPPA) Users Awaiting Moderation','',1,1,1,0,0,0,0,0,0,0,0)");
  $DB_site->query("INSERT INTO usergroup VALUES (5,'Super Moderator','Super Moderator',1,1,1,1,1,1,1,1,1,1,0)");
  $DB_site->query("INSERT INTO usergroup VALUES (6,'Administrator','Administrator',1,1,1,1,1,1,1,1,1,1,1)");
  echo "succeeded</p>";

  echo "<p>Setting up user titles...";
  $DB_site->query("INSERT INTO usertitle VALUES (NULL,0,'Junior Member')");
  $DB_site->query("INSERT INTO usertitle VALUES (NULL,30,'Member')");
  $DB_site->query("INSERT INTO usertitle VALUES (NULL,100,'Senior Member')");
  echo "succeeded</p>";

  echo "<p>All tables successfully populated. The next step will set up the templates.";
  echo "<p><a href=\"install.php?step=6\">Click here to continue -></a></p>";
}

if ($step==6) {
  // do templates
?><head><title>vBulletin Install Wizard <?php echo $version; ?> - Set up templates</title></head>
<body><p>Setting up templates...</p><?php

  $filename="installtemplate.php";
  include($filename);

  echo "<p>Templates set up successfully. The next step will allow you to set up the options for this board.</p>";
  echo "<p><a href=\"install.php?step=7\">Click here to continue -></a></p>";

}

if ($step==7) {
?><head><title>vBulletin Install Wizard <?php echo $version; ?> - Set options</title></head>
<body>

<form action="install.php" method="post">
<input type="hidden" name="step" value="8">

<table border=0>

<tr>
<td><b>BB Title</b></td>
<td><input type="text" size="35" name="bbtitle" value=""></td>
</tr>
<tr><td colspan=2>Title of board. Appears in the title of every page.<br></td></tr>

<tr>
<td><b>Home Title</b></td>
<td><input type="text" size="35" name="hometitle" value=""></td>
</tr>
<tr><td colspan=2>Name of your homepage. Appears at the bottom of every page.<br></td></tr>

<tr>
<td><b>BB URL</b></td>
<td><input type="text" size="35" name="bburl" value="http://www.yourhost.com/forums"></td>
</tr>
<tr><td colspan=2>URL (with no final "/") of the BB.<br></td></tr>

<tr>
<td><b>Home URL</b></td>
<td><input type="text" size="35" name="homeurl" value="http://www.yourhost.com/"></td>
</tr>
<tr><td colspan=2>URL of your home page. Appears at the bottom of every page.<br></td></tr>

<tr>
<td><b>Webmaster email address</b></td>
<td><input type="text" size="35" name="webmasteremail" value="webmaster@yourhost.com"></td>
</tr>
<tr><td colspan=2>Email address of the webmaster.<br></td></tr>

<tr>
<td><b>Technical Email address</b></td>
<td><input type="text" size="35" name="technicalemail" value="tech@yourhost.com"></td>
</tr>
<tr><td colspan=2>Email address of the technical contact for the BB. This receives all database errors.<br></td></tr>

</table>
<input type=submit value="Submit Options and Continue to next step">
</form>
<?php

}

if ($step==8) {
?><head><title>vBulletin Install Wizard <?php echo $version; ?> - Set options</title></head>
<body><p>Setting up options...</p><?php

$DB_site->query("INSERT INTO template VALUES (NULL,'options','\$bbactive = \"1\";
\$bbclosedreason = \"Sorry. The administrator has disabled this bulletin board at the moment for maintenance.\";
\$bbtitle = \"".addslashes($bbtitle)."\";
\$hometitle = \"".addslashes($hometitle)."\";
\$bburl = \"".addslashes($bburl)."\";
\$homeurl = \"".addslashes($homeurl)."\";
\$copyrighttext = \"\";
\$privacyurl = \"\";
\$contactuslink = \"mailto:".addslashes($webmasteremail)."\";
\$webmasteremail = \"".addslashes($webmasteremail)."\";
\$technicalemail = \"".addslashes($technicalemail)."\";
\$faxnumber = \"\";
\$address = \"\";
\$companyname = \"\";
\$allowbbimagecode = \"0\";
\$allowbbcode = \"1\";
\$allowsmilies = \"1\";
\$allowhtml = \"0\";
\$maximages = \"10\";
\$usecategories = \"1\";
\$categoriesonly = \"0\";
\$showforumdescriptions = \"1\";
\$displayloggedin = \"1\";
\$hideprivateforums = \"0\";
\$displayemails = \"1\";
\$secureemail = \"1\";
\$allowsignatures = \"1\";
\$newuseremail = \"\";
\$requireuniqueemail = \"1\";
\$illegalusernames = \"\";
\$allowregistration = \"1\";
\$allowmultiregs = \"0\";
\$verifyemail = \"0\";
\$moderatenewmembers = \"0\";
\$usecoppa = \"1\";
\$cookietimeout = \"900\";
\$cookiepath = \"/\";
\$enablememberlist = \"1\";
\$usememberlistadvsearch = \"1\";
\$memberlistperpage = \"30\";
\$memberlisttopposters = \"10\";
\$postsorder = \"0\";
\$maxposts = \"15\";
\$pagenavpages = \"3\";
\$wordwrap = \"100\";
\$usehotthreads = \"1\";
\$hotnumber = \"15\";
\$linktopages = \"1\";
\$showicons = \"1\";
\$maxthreads = \"40\";
\$maxmultipage = \"6\";
\$allowsearches = \"1\";
\$enableemail = \"1\";
\$timeoffset = \"0\";
\$timezone = \"ET (US)\";
\$dateformat = \"m-d-Y\";
\$timeformat = \"h:i A\";
\$registereddateformat = \"M Y\";
\$enablecensor = \"0\";
\$censorwords = \"\";
\$censorchar = \"*\";
\$showeditedby = \"1\";
\$noeditedbytime = \"2\";
\$showeditedbyadmin = \"1\";
\$edittimelimit = \"0\";
\$logip = \"1\";
\$enablefloodcheck = \"0\";
\$floodchecktime = \"60\";
\$enablebanning = \"0\";
\$banip = \"\";
\$banemail = \"\";
\$titleimage = \"images/bbtitle.jpg\";
\$replyimage = \"images/reply.gif\";
\$newthreadimage = \"images/newthread.gif\";
\$closedthreadimage = \"images/threadclosed.gif\";
\$useadvheader = \"0\";
\$useadvfooter = \"0\";
\$ontext = \"ON\";
\$offtext = \"OFF\";
\$versionnumber = \"$version\";
')");

  echo "<p>Options added and set successfully. Please continue to the next step to set yourself up as an administrator.</p>";
  echo "<p><a href=\"install.php?step=9\">Click here to continue -></a></p>";

}

if ($step==9) {
?><head><title>vBulletin Install Wizard <?php echo $version; ?> - Set up administrator</title></head>
<body><p>Please fill in the form below to set yourself up as an administrator...</p>

<form action="install.php" method="post">
<input type="hidden" name="step" value="10">

<table border=0>

<tr>
<td>User Name</td>
<td><input type="text" size="35" name="username"></td>
</tr>
<tr>
<td>Password</td>
<td><input type="text" size="35" name="password"></td>
</tr>
<tr>
<td>Email Address</td>
<td><input type="text" size="35" name="email"></td>
</tr>
</table>
<input type=submit value="Submit form and Continue to next step">
</form>
<?php

}

if ($step==10) {
?><head><title>vBulletin Install Wizard <?php echo $version; ?> - Completed</title></head>
<body><p>Setting you up as an administrator...</p><?php

  if ($username=="" or $password=="" or $email=="") {
    echo "<p>Please complete all the fields.</p>";
  } else {
    $DB_site->query("INSERT INTO user (userid,usergroupid,username,password,email,adminemail,showemail,joindate,canpost,cookieuser,daysprune,lastvisit,lastactivity,lastpost) VALUES (NULL,6,'".addslashes($username)."','".addslashes($password)."','".addslashes($email)."',1,1,".time().",1,1,-1,".time().",".time().",".time().")");

    echo "<p>Set up successfully!</p>";
    echo "<p>You have now completed the install of vBulletin. Once you have deleted this install script you can proceed to the control panel. You will not be able to access the control panel until you delete this script for security reasons.</p>";

    echo "<p>These are the files the you must delete: install.php installtemplate.php</p>";
    echo "<p>The control panel can be found <a href='index.php'>here</a></p>";
  }
}

echo "</"."body>";
echo "<"."!--";
?>

-->
</html>