<?php

if (function_exists("set_time_limit")==1 and get_cfg_var("safe_mode")==0) {
  set_time_limit(1200);
}

require ("global.php");

function wordsonly ($text) {

  $text=strtolower($text);

  echo "-";
  flush();
  $text=ereg_replace("<pre>[^<]*</pre>"," ",$text);
  echo "-";
  flush();
  $text=ereg_replace("<[^>]*>"," ",$text); // remove HTML <> tags
  echo "-";
  flush();
  $text=ereg_replace("&[^;];"," ",$text); // remove HTML special chars
  echo "-";
  flush();
  $text=ereg_replace("[^ 0-9a-z]"," ",$text); // keep only letters and numbers
  echo "-";
  flush();

  $counter=0;

  $words=explode(" ",$text);
  while (list($key,$val)=each($words)) {
    if ($val!="the" and $val!="this" and $val!="and" and $val!="but" and $val!="was" and $val!="that" and $val!="with" and $val!="its" and $val!="you" and $val!="they" and $val!="what" and $val!="why" and $val!="for" and $val!="are" and $val!="our" and $val!="then" and $val!="there" and $val!="which") {
      $counter++;
      $wordarray[$val]=1;
    }
  }

  if ($counter>0) {
    while (list($key,$val)=each($wordarray)) {
      $newwords[]=$key;
    }

    $newwords=implode($newwords," ");
  } else {
    $newwords="";
  }

  return $newwords;
}


?>
<html>
<head>
<STYLE type=text/css>
BODY {
  font-family: arial;
  font-size: 10pt;
  font-variant: normal;
  font-style: normal;
}
P {
  font-family: arial;
  font-size: 10pt;
  font-variant: normal;
  font-style: normal;
}
</STYLE>
</head>
<body>

<?php
// ###################### Start user choices #######################
if (isset($action)==0 or $action=="") {

  echo "<p><b>Update Users Info</b> - updates user titles<br>\n";

  echo doformheader("misc","updateuser");
  echo "<table border=0>";
  echo makeinputcode("Number of users to do per cycle","perpage","1000");
  echo doformfooter();

  echo "<p><b>Update Forums Info</b> - update forum post counts<br>\n";

  echo doformheader("misc","updateforum");
  echo "<table border=0>";
  echo makeinputcode("Number of forums to do per cycle","perpage","100");
  echo doformfooter();

  echo "<p><b>Update Thread Info</b> - update thread post counts, original posters and last post date<br>\n";

  echo doformheader("misc","updatethread");
  echo "<table border=0>";
  echo makeinputcode("Number of threads to do per cycle","perpage","2000");
  echo doformfooter();

  echo "<p><b>Rebuild search Index</b><br>\n";

  echo doformheader("misc","buildsearchindex");
  echo "<table border=0>";
  echo makeinputcode("Number of threads to do per cycle","perpage","500");
  echo doformfooter();

  echo "<p><b>Remove dupe threads</b> - (quite server intensive, but useful after importing posts)<br>\n";

  echo doformheader("misc","removedupe");
  echo "<table border=0>";
  echo makeinputcode("Number of threads to do per cycle","perpage","2000");
  echo doformfooter();
}

// ###################### Start build search index #######################
if ($action=="buildsearchindex") {
  if (isset($perpage)==0 or $perpage=="") {
    $perpage=500;
  }
  if (isset($startat)==0 or $startat=="") {
    $startat=0;
  }
  $finishat=$startat+$perpage;

  echo "<p>Building index..</p>";
  $threads=$DB_site->query("SELECT DISTINCT thread.threadid,thread.title FROM post,thread WHERE thread.threadid=post.threadid AND thread.threadid>=$startat AND thread.threadid<$finishat AND thread.visible=1 ORDER BY thread.threadid");
  while ($thread=$DB_site->fetch_array($threads)) {

    $subject="";
    $pagetext="";
    $usernames="";

    echo "<p>Gathering data for thread$thread[threadid]<br>";
    flush();

    $subject=$thread[title];

    $posts=$DB_site->query("SELECT userid,username,pagetext FROM post WHERE threadid=$thread[threadid] AND visible=1");
    while ($post=$DB_site->fetch_array($posts)) {
      if ($post[userid]!=0) {
        if ($getuser=$DB_site->query_first("SELECT username FROM user WHERE userid=$post[userid]")) {
          $usernames.=" $getuser[username] ";
        }
      } else {
        $usernames.=" $post[username] ";
      }
      $pagetext.=" $post[pagetext] ";
    }

    $subject=wordsonly($subject);
    $pagetext=$subject." ".wordsonly($pagetext);
    $usernames=wordsonly($usernames);

    $DB_site->query("UPDATE thread SET subjectindex=' ".addslashes($subject)." ',threadindex=' ".addslashes($pagetext)." ',userindex=' ".addslashes($usernames)." ' WHERE threadid=$thread[threadid]");
    echo "</p>\n";
    flush();

  }

  if ($checkmore=$DB_site->query_first("SELECT threadid FROM thread WHERE threadid>=$finishat")) {
    echo "<script language=\"javascript\">window.location=\"misc.php?action=buildsearchindex&startat=$finishat&perpage=$perpage\";</script>";
    echo "<p><a href=\"misc.php?action=buildsearchindex&startat=$finishat&perpage=$perpage\">Click here to continue building search engine</a></p>";
  } else {
    echo "<p>All done!</p>";
  }
}


// ###################### Start update user #######################
if ($action=="updateuser") {
  if (isset($perpage)==0 or $perpage=="") {
    $perpage=1000;
  }
  if (isset($startat)==0 or $startat=="") {
    $startat=0;
  }
  $finishat=$startat+$perpage;

  echo "<p>User ids:</p>";

  $users=$DB_site->query("SELECT userid,usertitle,usergroupid,customtitle,posts FROM user WHERE userid>=$startat AND userid<$finishat ORDER BY userid DESC");
  while ($user=$DB_site->fetch_array($users)) {

    $userid=$user[userid];

    // update user stuff
    if ($user[customtitle]==0) {
      $usergroup=$DB_site->query_first("SELECT usertitle FROM usergroup WHERE usergroupid=$user[usergroupid]");
      if ($usergroup[usertitle]=="") {
        $gettitle=$DB_site->query_first("SELECT title FROM usertitle WHERE minposts<=$user[posts] ORDER BY minposts DESC LIMIT 1");
        $usertitle=$gettitle[title];
      } else {
        $usertitle=$usergroup[usertitle];
      }

      $sql="usertitle='".addslashes($usertitle)."',";
    }

    if ($user[posts]==0) {
      $lastpostdate=0;
    } else {
      if ($lastpost=$DB_site->query_first("SELECT dateline FROM post WHERE userid=$userid ORDER BY dateline DESC LIMIT 1")) {
        $lastpostdate=intval($lastpost[dateline]);
        if (trim($lastpostdate)=="") {
          $lastpostdate=0;
        }
      } else {
        $lastpostdate=0;
      }
    }

    $DB_site->query("UPDATE user SET $sql"."lastpost=$lastpostdate WHERE userid=$user[userid]");

    echo "$user[userid]<br>\n";
    flush();

  }
  if ($checkmore=$DB_site->query_first("SELECT userid FROM user WHERE userid>=$finishat")) {
    echo "<script language=\"javascript\">window.location=\"misc.php?action=updateuser&startat=$finishat&perpage=$perpage\";</script>";
    echo "<p><a href=\"misc.php?action=updateuser&startat=$finishat&perpage=$perpage\">Click here to continue updating users</a></p>";
  } else {
    echo "<p>All done!</p>";
  }

}

// ###################### Start update forum #######################
if ($action=="updateforum") {
  if (isset($perpage)==0 or $perpage=="") {
    $perpage=100;
  }
  if (isset($startat)==0 or $startat=="") {
    $startat=0;
  }
  $finishat=$startat+$perpage;

  echo "<p>Forum ids:</p>";

  $forums=$DB_site->query("SELECT forumid FROM forum WHERE forumid>=$startat AND forumid<$finishat ORDER BY forumid DESC");
  while ($forum=$DB_site->fetch_array($forums)) {

    $forumid=$forum[forumid];

    echo "$forumid<br>\n";
    flush();

    if ($numpost=$DB_site->query_first("SELECT COUNT(postid) AS posts FROM post,thread WHERE thread.threadid=post.threadid AND thread.forumid=$forumid")) {
      $numberposts=$numpost[posts];
    } else {
      $numberposts=0;
    }

    if ($numpost=$DB_site->query_first("SELECT COUNT(threadid) AS posts FROM thread WHERE thread.forumid=$forumid")) {
      $numberthreads=$numpost[posts];
    } else {
      $numberthreads=0;
    }

    if ($lastposts=$DB_site->query_first("SELECT lastpost,lastposter FROM thread WHERE forumid=$forumid ORDER BY lastpost DESC LIMIT 1")) {
      $lastpost=$lastposts[lastpost];
      $lastposter=$lastposts[lastposter];
    } else {
      $lastpost=0;
      $lastposter="";
    }

    $DB_site->query("UPDATE forum SET replycount=$numberposts,threadcount=$numberthreads,lastpost=$lastpost,lastposter='".addslashes($lastposter)."' WHERE forumid=$forumid");

  }
  if ($checkmore=$DB_site->query_first("SELECT forumid FROM forum WHERE forumid>=$finishat")) {
    echo "<script language=\"javascript\">window.location=\"misc.php?action=updateforum&startat=$finishat&perpage=$perpage\";</script>";
    echo "<p><a href=\"misc.php?action=updateforum&startat=$finishat&perpage=$perpage\">Click here to continue updating forums</a></p>";
  } else {
    echo "<p>All done!</p>";
  }
}

// ###################### Start update threads #######################
if ($action=="updatethread") {

  if (isset($perpage)==0 or $perpage=="") {
    $perpage=2000;
  }
  if (isset($startat)==0 or $startat=="") {
    $startat=0;
  }
  $finishat=$startat+$perpage;
  echo "<p>Thread ids:</p>";

  $threads=$DB_site->query("SELECT MIN(post.postid) AS minpost,MAX(post.postid) AS maxpost,thread.threadid,MAX(post.dateline) AS dateline,(COUNT(post.postid)-1) AS posts FROM post,thread WHERE thread.threadid=post.threadid AND thread.threadid>=$startat AND thread.threadid<$finishat GROUP BY thread.threadid ORDER BY threadid DESC");
  while ($thread=$DB_site->fetch_array($threads)) {

    $threadid=$thread[threadid];

    echo "$threadid<br>\n";
    flush();

    $numberposts=$thread[posts];
    $lastpost=$thread[dateline];
    $firstusername=$DB_site->query_first("SELECT username,userid FROM post WHERE postid=$thread[minpost]");
    if ($firstusername[userid]==0) {
      $firstusername=$firstusername[username];
    } else {
      $users=$DB_site->query_first("SELECT username FROM user WHERE userid=$firstusername[userid]");
      $firstusername=$users[username];
    }

    $lastusername=$DB_site->query_first("SELECT username,userid FROM post WHERE postid=$thread[maxpost]");
    if ($lastusername[userid]==0) {
      $lastusername=$lastusername[username];
    } else {
      $users=$DB_site->query_first("SELECT username FROM user WHERE userid=$lastusername[userid]");
      $lastusername=$users[username];
    }


    $DB_site->query("UPDATE thread SET lastpost=$lastpost,replycount=$numberposts,postusername='".addslashes($firstusername)."',lastposter='".addslashes($lastusername)."' WHERE threadid=$threadid");
  }
  if ($checkmore=$DB_site->query_first("SELECT threadid FROM thread WHERE threadid>=$finishat")) {
    echo "<script language=\"javascript\">window.location=\"misc.php?action=updatethread&startat=$finishat&perpage=$perpage\";</script>";
    echo "<p><a href=\"misc.php?action=updatethread&startat=$finishat&perpage=$perpage\">Click here to continue updating threads</a></p>";
  } else {
    echo "<p>All done!</p>";
  }

}
// ###################### Start remove dupe #######################
if ($action=="removedupe") {

  if (isset($perpage)==0 or $perpage=="") {
    $perpage=2000;
  }
  if (isset($startat)==0 or $startat=="") {
    $startat=0;
  }
  $finishat=$startat+$perpage;
  echo "<p>Thread ids:</p>";

  $threads=$DB_site->query("SELECT threadid,title,forumid,postusername,dateline FROM thread WHERE threadid>=$startat AND threadid<$finishat ORDER BY threadid");
  while ($thread=$DB_site->fetch_array($threads)) {

    $threadid=$thread[threadid];

    echo "$threadid<br>\n";
    flush();

    $deletethreads=$DB_site->query("SELECT threadid FROM thread WHERE title='".addslashes($thread[title])."' AND forumid=$thread[forumid] AND postusername='".addslashes($thread[postusername])."' AND dateline=$thread[dateline] AND threadid>$thread[threadid]");

    while ($deletethread=$DB_site->fetch_array($deletethreads)) {
      $DB_site->query("DELETE FROM post WHERE threadid=$deletethread[threadid]");
      $DB_site->query("DELETE FROM thread WHERE threadid=$deletethread[threadid]");
      echo "<p>Deleted thread $deletethread[threadid]</p>";
    }

  }
  if ($checkmore=$DB_site->query_first("SELECT threadid FROM thread WHERE threadid>=$finishat")) {
    echo "<script language=\"javascript\">window.location=\"misc.php?action=removedupe&startat=$finishat&perpage=$perpage\";</script>";
    echo "<p><a href=\"misc.php?action=removedupe&startat=$finishat&perpage=$perpage\">Click here to continue removing duplicates</a></p>";
  } else {
    echo "<p>All done!</p>";
  }

}

?>
</body>
</html>